import casadi as ca


def ballistic_dynamics( x ):

    w = 2
    d = .1
    g = 9.81

    v = x[2:4]
    dnorm = ca.norm_2(v - ca.vertcat(w, 0))

    xdot  = ca.vertcat(
        v[0],
        v[1],
        -(v[0] - w) * dnorm  * d,
        -v[1]  * dnorm * d - g
    )

    return xdot
